"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.modulesImportHandler = void 0;
var tslib_1 = require("tslib");
var path_1 = require("path");
var create_imports_transformer_1 = require("./create-imports-transformer");
/**
 * Request handler which is responsible for serving es6 module source code.
 * @internal
 * @param config - configuration
 * @param sourceProvider - source provider
 */
var modulesImportHandler = function (config, sourceProvider) {
    return function (req, res, next) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var source, importQuery, importContextQuery, ext;
        var _a, _b;
        return tslib_1.__generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    importQuery = req.query[create_imports_transformer_1.importQueryParam];
                    importContextQuery = req.query[create_imports_transformer_1.importContextQueryParam];
                    req.moduleImport = !!importQuery;
                    req.moduleImportContext = typeof importContextQuery === 'string'
                        ? importContextQuery
                        : undefined;
                    ext = path_1.extname(req.path);
                    if (!(req.moduleImport
                        && (((_b = (_a = config.resolve) === null || _a === void 0 ? void 0 : _a.extensions) === null || _b === void 0 ? void 0 : _b.indexOf(ext)) || -1) > -1)) return [3 /*break*/, 2];
                    return [4 /*yield*/, sourceProvider("" + (req.moduleImportContext || '') + req.path)];
                case 1:
                    source = _c.sent();
                    return [3 /*break*/, 4];
                case 2:
                    if (!(req.path.endsWith('.ts') || req.path.endsWith('.tsx'))) return [3 /*break*/, 4];
                    return [4 /*yield*/, sourceProvider(req.path)];
                case 3:
                    source = _c.sent();
                    _c.label = 4;
                case 4:
                    if (source) {
                        res.contentType('application/javascript');
                        res.send(source);
                    }
                    else {
                        next();
                    }
                    return [2 /*return*/];
            }
        });
    }); };
};
exports.modulesImportHandler = modulesImportHandler;
//# sourceMappingURL=modules-import-handler.js.map