import { __awaiter, __generator } from "tslib";
import { extname } from 'path';
import { importContextQueryParam, importQueryParam } from './create-imports-transformer';
/**
 * Request handler which is responsible for serving es6 module source code.
 * @internal
 * @param config - configuration
 * @param sourceProvider - source provider
 */
export var modulesImportHandler = function (config, sourceProvider) {
    return function (req, res, next) { return __awaiter(void 0, void 0, void 0, function () {
        var source, importQuery, importContextQuery, ext;
        var _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    importQuery = req.query[importQueryParam];
                    importContextQuery = req.query[importContextQueryParam];
                    req.moduleImport = !!importQuery;
                    req.moduleImportContext = typeof importContextQuery === 'string'
                        ? importContextQuery
                        : undefined;
                    ext = extname(req.path);
                    if (!(req.moduleImport
                        && (((_b = (_a = config.resolve) === null || _a === void 0 ? void 0 : _a.extensions) === null || _b === void 0 ? void 0 : _b.indexOf(ext)) || -1) > -1)) return [3 /*break*/, 2];
                    return [4 /*yield*/, sourceProvider("" + (req.moduleImportContext || '') + req.path)];
                case 1:
                    source = _c.sent();
                    return [3 /*break*/, 4];
                case 2:
                    if (!(req.path.endsWith('.ts') || req.path.endsWith('.tsx'))) return [3 /*break*/, 4];
                    return [4 /*yield*/, sourceProvider(req.path)];
                case 3:
                    source = _c.sent();
                    _c.label = 4;
                case 4:
                    if (source) {
                        res.contentType('application/javascript');
                        res.send(source);
                    }
                    else {
                        next();
                    }
                    return [2 /*return*/];
            }
        });
    }); };
};
//# sourceMappingURL=modules-import-handler.js.map